cryptonite-0.9: Cryptography Primitives sink

License | BSD-style
Maintainer | Vincent Hanquez <vincent@snarc.org>
Stability | experimental
Portability | Good
Safe Haskell | None
Language | Haskell2010

Crypto.PubKey.DH

Description

Synopsis

- data Params = Params {
  - params_p :: Integer
  - params_g :: Integer
  }
- newtype PublicNumber = PublicNumber Integer
- newtype PrivateNumber = PrivateNumber Integer
- newtype SharedKey = SharedKey Integer
- generateParams :: MonadRandom m => Int -> Integer -> m Params
- generatePrivate :: MonadRandom m => Params -> m PrivateNumber
- calculatePublic :: Params -> PrivateNumber -> PublicNumber
- generatePublic :: Params -> PrivateNumber -> PublicNumber
- getShared :: Params -> PrivateNumber -> PublicNumber -> SharedKey

# Documentation

data Params

Represent Diffie Hellman parameters namely P (prime), and G (generator).

Constructors

Params |
Fields params_p :: Integer params_g :: Integer

Instances

Eq Params |
Data Params |
Read Params |
Show Params |

newtype PublicNumber

Represent Diffie Hellman public number Y.

Constructors

PublicNumber Integer |

Instances

Enum PublicNumber |
Eq PublicNumber |
Num PublicNumber |
Ord PublicNumber |
Read PublicNumber |
Real PublicNumber |
Show PublicNumber |

newtype PrivateNumber

Represent Diffie Hellman private number X.

Constructors

PrivateNumber Integer |

Instances

Enum PrivateNumber |
Eq PrivateNumber |
Num PrivateNumber |
Ord PrivateNumber |
Read PrivateNumber |
Real PrivateNumber |
Show PrivateNumber |

newtype SharedKey

Represent Diffie Hellman shared secret.

Constructors

SharedKey Integer |

Instances

Enum SharedKey |
Eq SharedKey |
Num SharedKey |
Ord SharedKey |
Read SharedKey |
Real SharedKey |
Show SharedKey |

generateParams

Arguments

:: MonadRandom m |
=> Int | number of bits
-> Integer | generator
-> m Params |

generate params from a specific generator (2 or 5 are common values) we generate a safe prime (a prime number of the form 2p+1 where p is also prime)

generatePrivate :: MonadRandom m => Params -> m PrivateNumber

generate a private number with no specific property this number is usually called X in DH text.

calculatePublic :: Params -> PrivateNumber -> PublicNumber

calculate the public number from the parameters and the private key this number is usually called Y in DH text.

generatePublic :: Params -> PrivateNumber -> PublicNumber

calculate the public number from the parameters and the private key this number is usually called Y in DH text.

DEPRECATED use calculatePublic

getShared :: Params -> PrivateNumber -> PublicNumber -> SharedKey

generate a shared key using our private number and the other party public number